//ADVISOR 2012 V1.10
extern string Attention = "TRADER";
extern string HeadLine = "ADVISOR 2012 V1.0";
extern string BuyBlock = "BUY";

extern double Buy_PipStepExponent = 1;
extern double Buy_LotExponent = 1.0;
extern double Buy_LotSize = 0.10;
extern double Buy_Price = 1.2915;
extern int Buy_PipStep = 20;
extern int Buy_TP = 10;
extern int Buy_MaxTrades=10;

extern string GeneralBlock = "GENERAL BLOCK";

extern int OpenNewTF = 1;
extern int OpenNextTF = 1;
extern bool BackBar = false;
extern int BackBarTF = 30;
extern bool FixLot=true;
extern int LotStep = 2000;

extern string OfficialVariable = "OFFICIAL VARIABLE";
extern string MaxAttemptsString = "MAX ATTEMPTS";
extern int MaxAttempts = 5;
extern string InformationOnChartString = "INFORMATION ON CHART";
extern bool InformationOnChart = true;
extern int MagicNumber = 000307;

datetime timeprevMIN=0;
datetime timeprevMAX=0;
extern int LotDecimal = 0;
int total, ticket, CountTrades;
bool LongTradeNew;
double Buy_NextLot, Buy_NewLot, Buy_LastLot;
string CommentTrades;

int init()
  {

   LotDecimal = LotDecimal();

   return(0);
  }

int deinit()
  {

   return(0);
  }

int start()
{
   
   int j;
   
   if (LotDecimal==0) LotDecimal = LotDecimal();
   
   Information();
   
   LongTradeNew=true;
   
     
   if(timeprevMIN!=iTime(NULL,OpenNewTF,0))
   {
      CountTrades = CountTrades("buy");
      if (CountTrades==0 && Ask<Buy_Price && LongTradeNew==true)
      {
         CommentTrades = "LONG ADVISOR 2012 V1.0"+Symbol()+" - Buy "+(CountTrades+1);
         Buy_NewLot = NewLot("buy");
         
         ticket=0;
         for (j = 0; ticket < 1 && j < MaxAttempts; j++)
         {
            Print("NEW POSITION OPENED on CURRENCY PAIR: "+Symbol()+", LOT= "+Buy_NewLot+", PRICE= "+Ask+", ADVISOR= "+CommentTrades+" NUMBER= "+MagicNumber);
            ticket = OrderSend(Symbol(),OP_BUY,Buy_NewLot,Ask,3,0,0,CommentTrades,MagicNumber,0,Blue);
            if(ticket<0) Sleep(10000);
         }   
         if(ticket<0) 
         {
            Print("ERROR: ",GetLastError()); 
         } else {
            RefreshRates();
         }   
      }
      orrect("buy");
      timeprevMIN=iTime(NULL,OpenNewTF,0);
   }    
   
   if(timeprevMAX!=iTime(NULL,OpenNextTF,0))
   {
      CountTrades = CountTrades("buy");
      if (CountTrades>0 && NextOrder("buy"))
      {
         CommentTrades = "LONG ADVISOR 2012 V1.0"+Symbol()+" - Buy "+(CountTrades+1);
         Buy_NextLot = NextLot("buy");
         ticket = 0;
         for (j = 0; ticket < 1 && j < MaxAttempts; j++)
         {
            Print("NEXT POSITION OPENED on CURRENCY PAIR: "+Symbol()+", LOT= "+Buy_NextLot+", PRICE= "+Ask+", ADVISOR= "+CommentTrades+", NUMBER= "+MagicNumber);
            ticket = OrderSend(Symbol(),OP_BUY,Buy_NextLot,Ask,3,0,0,CommentTrades,MagicNumber,0,Blue);
            if(ticket<0) Sleep(10000);
         }   
         
         if(ticket<0) 
         {
            Print("ERROR: ",GetLastError()); 
         } else {
            Buy_LastLot = Buy_NextLot;
            RefreshRates();
            orrect("buy");
         }   
      } 
      timeprevMAX=iTime(NULL,OpenNextTF,0);
   }
   
   return(0);
  }

void orrect(string OrdType) 
{
   int trade;
   double TP_all;
   double AveragePrice;
   
   AveragePrice = AveragePrice(OrdType);
   
   for(trade=OrdersTotal()-1;trade>=0;trade--)
   {
      OrderSelect(trade, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber) continue;
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
         {
         
            if (OrdType=="buy")
            {
               if(OrderType()==OP_BUY)
               {
                  TP_all = AveragePrice+Buy_TP*Point;
                  if (OrderTakeProfit() != TP_all)
                  {
                     Print("POSITIONS CLOSED. PRICE= "+AveragePrice+", SUBTOTAL= "+Buy_TP+" TOTAL= "+TP_all);
                     OrderModify(OrderTicket(), AveragePrice, OrderStopLoss(), TP_all, 0, Yellow);
                  }
                  
               }   
            }
            
         }   
    }        
} 


//NEW LOTS STRING:
double NewLot(string OrdType)
{
   double tLots;
   double minlot = MarketInfo(Symbol(), MODE_MINLOT);
   
   if (OrdType=="buy")
   {
      if (FixLot) tLots = Buy_LotSize; else tLots = NormalizeDouble(Buy_LotSize * NormalizeDouble(AccountBalance()/LotStep,0), LotDecimal); 
   }

   if(tLots < minlot) tLots = minlot; 
            
   return(tLots);
}  

//NEXT LOT STRING:
double NextLot(string OrdType)
{

   double tLots;
   
   if (OrdType=="buy")
   {
      tLots=NormalizeDouble(FindLastOrder(OrdType, "Lots")*Buy_LotExponent,LotDecimal);
   }

   return(tLots);
}  

//NEXT POSITION STRING:
bool NextOrder(string OrdType)
{
   bool NextOrd = false;
   int PipStepEX;
   
   double CurrCl=iClose(Symbol(),BackBarTF,1);
   double CurrOp=iOpen(Symbol(),BackBarTF,1);
      
   if (OrdType=="buy")
   {
      PipStepEX = NormalizeDouble(Buy_PipStep*MathPow(Buy_PipStepExponent,CountTrades(OrdType)),0);
      if (FindLastOrder(OrdType, "Price") - Ask >= PipStepEX * Point && CountTrades(OrdType)<Buy_MaxTrades) 
      {
         if (BackBar) 
         {
            if (CurrOp <= CurrCl) NextOrd = TRUE; else NextOrd = false;
         } else {
            NextOrd = TRUE;
         }      
      }   
   }
   return(NextOrd);
}  

//LAST ORDER STRING:
double FindLastOrder(string OrdType, string inf)
{
   double OrderPrice;
   double LastLot;
   int trade, oldticketnumber=0;
   
   for(trade=OrdersTotal()-1;trade>=0;trade--)
   {
      OrderSelect(trade, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber) continue;
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
         {
         
            if (OrdType=="buy")
            {
               if(OrderType()==OP_BUY)
               {
                  if(OrderTicket()>oldticketnumber)
                  {
                     OrderPrice=OrderOpenPrice();
                     LastLot = OrderLots();
                     oldticketnumber=OrderTicket();
                  }
                }
             }

   }
}
if (inf=="Price") return(OrderPrice);
if (inf=="Lots")  return(LastLot);
}

//COUNT TRADES STRING:
int CountTrades(string OrdType)
{
   int count=0;
   int trade;
   for(trade=OrdersTotal()-1;trade>=0;trade--)
   {
      OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber) continue;
      if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
      {
      
         if (OrdType == "buy")
         {
            if(OrderType()==OP_BUY) count++;
         }

      }
   }
   return(count);
}

//AVERAGE PRICE STRING:
double AveragePrice(string OrdType)
{
   double AveragePrice=0;
   double Count=0;
   int trade;
   for(trade=OrdersTotal()-1;trade>=0;trade--)
   {
      OrderSelect(trade, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber) continue;
      if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
      {
     
         if (OrdType == "buy")
         {
            if(OrderType()==OP_BUY)
            {
               AveragePrice=AveragePrice+OrderOpenPrice()*OrderLots();
               Count=Count + OrderLots();
            }
         }

      }   
   }
   AveragePrice=NormalizeDouble(AveragePrice/Count, Digits);
      
  return(AveragePrice);    
}

//INFORMATION ON CHART:
void Information()
{
   if (InformationOnChart)
   {
      Comment("" 
      //+ "\n"                         
      + "\n"
      + "                              CURRENCY PAIR:   "+Symbol()                         
      + "\n"                         
      + "                              ------------------------------------------------"                         
      + "\n"                         
      + "                              BROKER:   " + AccountCompany()+"   LEVERAGE:  1:"+ DoubleToStr(AccountLeverage(), 0)                         
      + "\n"  
      + "                              ------------------------------------------------"
      + "\n"
      + "                              POSITIONS:   "+CountTrades("buy")+" of "+Buy_MaxTrades
      + "\n"
      + "                              LOTS:   " + DoubleToStr(Balance("buy", "Lot"), 2)
      + "\n"
      + "                              ------------------------------------------------"
      + "\n"
      + "                              BALANCE:   " + DoubleToStr(Balance("buy", "Balance"), 2)
      + "\n"

      );
      
   }
}

//BALANCE STRING:
double Balance(string OrdType, string inf)
{
   double result=0;
   int trade;
   for(trade=OrdersTotal()-1;trade>=0;trade--)
   {
      OrderSelect(trade, SELECT_BY_POS, MODE_TRADES);
      if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber) continue;
      if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
      {
   
         if (OrdType == "buy")
         {
            if(OrderType()==OP_BUY)
            {
               if (inf=="Balance") result=result+OrderProfit()-OrderSwap()-OrderCommission();
               if (inf=="Lot")     result=result+OrderLots();
            }
         }
          
      }   
   }
      
  return(result);    
}

double LotDecimal()
{
   double steplot=MarketInfo(Symbol(), MODE_LOTSTEP);
   int LotsDigits = MathCeil(MathAbs(MathLog(steplot)/MathLog(10)));

return(LotsDigits);
}


